"""
This type stub file was generated by pyright.
"""

import pathlib
from collections.abc import Hashable, Sequence
from typing import Any, Literal, TypeVar, Union
from . import path
from ._enums import CapStyle, JoinStyle
from .markers import MarkerStyle

"""
Typing support for Matplotlib

This module contains Type aliases which are useful for Matplotlib and potentially
downstream libraries.

.. admonition:: Provisional status of typing

    The ``typing`` module and type stub files are considered provisional and may change
    at any time without a deprecation period.
"""
RGBColorType = Union[tuple[float, float, float], str]
RGBAColorType = Union[str, tuple[float, float, float, float], tuple[RGBColorType, float], tuple[tuple[float, float, float, float], float],]
ColorType = Union[RGBColorType, RGBAColorType]
RGBColourType = RGBColorType
RGBAColourType = RGBAColorType
ColourType = ColorType
LineStyleType = Union[str, tuple[float, Sequence[float]]]
DrawStyleType = Literal["default", "steps", "steps-pre", "steps-mid", "steps-post"]
MarkEveryType = Union[None, int, tuple[int, int], slice, list[int], float, tuple[float, float], list[bool]]
MarkerType = Union[str, path.Path, MarkerStyle]
FillStyleType = Literal["full", "left", "right", "bottom", "top", "none"]
JoinStyleType = Union[JoinStyle, Literal["miter", "round", "bevel"]]
CapStyleType = Union[CapStyle, Literal["butt", "projecting", "round"]]
RcStyleType = Union[str, dict[str, Any], pathlib.Path, Sequence[Union[str, pathlib.Path, dict[str, Any]]],]
_HT = TypeVar("_HT", bound=Hashable)
HashableList = list[Union[_HT, "HashableList[_HT]"]]
